summaryrefslogtreecommitdiffstats
path: root/qt4
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2008-08-04 15:30:33 +0000
committer Eric Hameleers <alien@slackware.com>2008-08-04 15:30:33 +0000
commitc9cfe91e0cb12898623a81824643c9d2eec6f8fc (patch)
treebb99bb50ff4b0194c5111bfffcb8a1300e3dc2ed /qt4
parentb1926ddd156d21edeade7bcfbc3831101d9ab761 (diff)
downloadasb-c9cfe91e0cb12898623a81824643c9d2eec6f8fc.tar.gz
asb-c9cfe91e0cb12898623a81824643c9d2eec6f8fc.tar.xz
Initial revision
Diffstat (limited to 'qt4')
-rwxr-xr-xqt4/build/qt4.SlackBuild229
1 files changed, 229 insertions, 0 deletions
diff --git a/qt4/build/qt4.SlackBuild b/qt4/build/qt4.SlackBuild
new file mode 100755
index 00000000..f820c49f
--- /dev/null
+++ b/qt4/build/qt4.SlackBuild
@@ -0,0 +1,229 @@
+#!/bin/sh
+# $Id$
+# Copyright (c) 2008 Eric Hameleers <alien@slackware.com>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: qt4
+# Descr: Qt4 graphical toolkit
+# URL: http://trolltech.com/products/qt
+# Needs:
+# Changelog:
+# 4.4.1-1: 04/Aug/2008 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh qt4.SlackBuild --cleanup' to build a Slackware package.
+# The package (.tgz) plus descriptive .txt file are created in /tmp .
+# Install using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# Set initial variables:
+
+PRGNAM=qt4
+VERSION=${VERSION:-4.4.1}
+ARCH=${ARCH:-i486}
+BUILD=${BUILD:-1}
+TAG=${TAG:-alien}
+
+DOCS="GPL_EXCEPTION*.TXT INSTALL LICENSE.* OPENSOURCE-NOTICE.TXT
+ README* changes-*"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/qt-x11-opensource-src-${VERSION}.tar.gz"
+SRCURL="http://wftp.tu-chemnitz.de/pub/Qt/qt/source/qt-x11-opensource-src-${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Slackware 11 and up need other option (gcc > 3.3.x)
+if [ $(gcc -dumpversion | tr -d '.' |cut -c 1-2) -gt 33 ]; then
+ MOPT=tune
+else
+ MOPT=cpu
+fi
+
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
+ ;;
+ s390) SLKCFLAGS="-O2"
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ ;;
+ athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ ;;
+esac
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+if $(file ${SOURCE} | grep -q ": bzip2"); then
+ tar -xjvf ${SOURCE}
+elif $(file ${SOURCE} | grep -q ": gzip"); then
+ tar -xzvf ${SOURCE}
+fi
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
+
+echo Building ...
+export CXXFLAGS="$SLKCFLAGS"
+export CFLAGS="$SLKCFLAGS"
+export OPENSOURCE_CXXFLAGS="$SLKCFLAGS"
+echo "yes" | ./configure \
+ -prefix=/usr/lib/qt-${VERSION} \
+ -qt-gif \
+ -fast \
+ -no-exceptions \
+ -system-libpng \
+ -system-libjpeg \
+ -system-zlib \
+ -dbus \
+ -webkit \
+ -no-phonon \
+ -nomake examples \
+ -nomake demos \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+make 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+
+# Install all the needed stuff to the package dir
+# Use installwatch if available, to produce a logfile of the installation
+# process that is more easily readable:
+if $(which installwatch > /dev/null 2>&1); then
+ installwatch -o $OUTPUT/install-${PRGNAM}.log make INSTALL_ROOT=$PKG install
+else
+ make INSTALL_ROOT=$PKG install 2>&1 |tee $OUTPUT/install-${PRGNAM}.log
+fi
+
+( cd $PKG/usr/lib
+ ln -sf qt-${VERSION} qt4
+)
+
+# Ensure that the various qt4 binaries are found by cmake:
+mkdir -p $PKG/usr/bin
+( cd $PKG/usr/bin
+ for file in assistant assistant_adp designer linguist lrelease lupdate \
+ moc pixeltool qcollectiongenerator qdbus qdbuscpp2xml \
+ qdbusviewer qdbusxml2cpp qhelpconverter qhelpgenerator qmake \
+ qt3to4 qtconfig rcc uic uic3 xmlpatterns;
+ do
+ ln -sf /usr/lib/qt-${VERSION}/bin/${file} ${file}-qt4 ;
+ done
+)
+
+# Likewise for the pkg-config files:
+mkdir -p $PKG/usr/lib/pkgconfig
+( cd $PKG/usr/lib/pkgconfig
+ for file in Qt3Support.pc QtAssistantClient.pc QtCore.pc \
+ QtDBus.pc QtGui.pc QtNetwork.pc QtOpenGL.pc QtScript.pc \
+ QtSql.pc QtSvg.pc QtTest.pc QtUiTools.pc QtXml.pc ;
+ do
+ ln -sf /usr/lib/qt-$VERSION/lib/pkgconfig/$file . ;
+ done
+)
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cp -a $SRCDIR/$(basename $0) $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+( cd $PKG/usr/doc/$PRGNAM-$VERSION ; ln -sf /usr/lib/qt-$VERSION/doc/html . )
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Strip binaries:
+cd $PKG
+find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+cd -
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+
+# Clean up the extra stuff:
+if [ "$P1" = "--cleanup" ]; then
+ rm -rf $TMP/tmp-$PRGNAM
+ rm -rf $PKG
+fi